/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "int.h"
#include "port.h"
#include "watchdogtimer.h"
#include "lvi.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/

long	input0;
long	input1;
long	input2;
long	input3;
long	input4;
long	input5;
long	input6;
long	in_data;
long	hen_data;
char	hen_d[24];
char	ret_flg;
long	su;

unsigned short	ad_data;		/* ADł̎擾l			*/



void	led_port_clear(void)
{
	P4.0=1;
	P4.1=1;
	P4.2=1;
	P4.3=1;
	P2.2=0;
}

void	time_wait(long time)
{
	while(time!=0){
	time--;
	}
}

void	led_7seg_out(int data)
{
	P12=(P12|0x0e)&((data&0x07)<<1);
	P13=(P13|0x01)&((data&0x08)>>3);
}

void	led_disp(void)
{
		led_port_clear();
		P4.0=0;P4.1=0;P4.2=0;
		led_7seg_out(input0);
		P2.2=1;
		time_wait(150);
		led_port_clear();
		P4.0=1;P4.1=0;P4.2=0;
		led_7seg_out(input1);
		time_wait(150);
		led_port_clear();
		P4.0=0;P4.1=1;P4.2=0;
		led_7seg_out(input2);
		time_wait(150);
		led_port_clear();
		P4.0=1;P4.1=1;P4.2=0;
		led_7seg_out(input3);
		P2.2=1;
		time_wait(150);
		led_port_clear();
		P4.0=0;P4.1=0;P4.2=1;
		led_7seg_out(input4);
		time_wait(150);
		led_port_clear();
		P4.0=1;P4.1=0;P4.2=1;
		led_7seg_out(input5);
		time_wait(150);
		led_port_clear();
		P4.0=0;P4.1=1;P4.2=1;
		led_7seg_out(input6);
		P2.2=1;
		time_wait(150);
		led_port_clear();
}

void	input_clear(void)
{
	input0=0;
	input1=0;
	input2=0;
	input3=0;
	input4=0;
	input5=0;
	input6=0;
}

int		key_scan(void)
{
int	key_no;

	AD_Start(ADChannel0);
	AD_Read(&ad_data);

	key_no=255;
	if((ad_data>=827)&&(ad_data<=929)){
		key_no=1;
	}
	if((ad_data>=680)&&(ad_data<=783)){
		key_no=2;
	}
	if((ad_data>=534)&&(ad_data<=636)){
		key_no=3;
	}
	if((ad_data>=388)&&(ad_data<=490)){
		key_no=4;
	}
	if((ad_data>=241)&&(ad_data<=344)){
		key_no=5;
	}
	if((ad_data>=95)&&(ad_data<=197)){
		key_no=6;
	}

	if(key_no!=255){return key_no;}

	AD_Start(ADChannel1);
	AD_Read(&ad_data);

	key_no=255;
	if((ad_data>=827)&&(ad_data<=929)){
		key_no=7;
	}
	if((ad_data>=680)&&(ad_data<=783)){
		key_no=8;
	}
	if((ad_data>=534)&&(ad_data<=636)){
		key_no=9;
	}
	if((ad_data>=388)&&(ad_data<=490)){
		key_no=10;
	}
	if((ad_data>=241)&&(ad_data<=344)){
		key_no=0;
	}
	if((ad_data>=95)&&(ad_data<=197)){
		key_no=11;
	}

	return key_no;

}

void	suji_set(int key)
{
	if (ret_flg==0){
		input6=input5;
		input5=input4;
		input4=input3;
		input3=input2;
		input2=input1;
		input1=input0;
		input0=key;
	}
	else{
		input_clear();
		input0=key;
		ret_flg=0;
	}
}

void	port_clear(void)
{
	P3.0=1;
	P3.1=1;
	P4.4=1;
	P4.5=0;
	P2.3=0;

}

void	reset_out(void)
{
	P4.5=1;			/* CLEAR */
	time_wait(50);
	P4.5=0;
	time_wait(50);
	P4.4=0;			/* LATCH */
	time_wait(50);
	P4.4=1;
}

void	data_out(void)
{
int	i;

	in_data=input6*1000000+input5*100000+input4*10000+input3*1000+input2*100+input1*10+input0;
	if (in_data>5000000) {
		in_data=5000000;
		input_clear();
		input6=5;
	}

	if (in_data>=1000000){
		P2.3=1;
	}
	else{
		P2.3=0;
	}
	
	su=0;
	while (in_data>=16000){
		in_data=in_data-16000;
		su++;
	}

	hen_data=in_data*256*512/78125;
	hen_data=hen_data+su*26843;
	su=su/2;
	hen_data=hen_data+su;

	for (i=0;i<24;i++){
		hen_d[i]=(char)(hen_data%2);
		hen_data=hen_data >> 1;
	}

	for (i=0;i<24;i++){
		P3.1=~(hen_d[23-i] & 0x01);
		time_wait(50);
		P3.0=0;
		time_wait(50);
		P3.0=1;
	}

	P4.4=0;			/* LATCH */
	time_wait(50);
	P4.4=1;
}

void	main( void )
{

	char	scan_key1;
	char	scan_key2;
	char	scan_f;

	scan_f=0;
	ret_flg=0;

	input_clear();
	port_clear();
	reset_out();

	/* TODO. add user code */
	while(1){

		scan_key1=key_scan();
		led_disp();
		scan_key2=key_scan();
		if(scan_key1==scan_key2){
			if(scan_key1!=255){
				if(scan_f==0){
						switch(scan_key1){
							case 10:input_clear();
									reset_out();
									ret_flg=0;
									break;
							case 11:data_out();
									ret_flg=1;
									break;
							case 0:
							case 1:
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
							case 7:
							case 8:
							case 9:	suji_set(scan_key1);
									break;
						}
						scan_f=1;
				}
			}
		}
		else{
			scan_f=0;
		}



	
		;
	}
}

